diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java
index 833b062c0..1d2bf9fa3 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java
@@ -16,17 +16,24 @@ public class MenuFurnaceBlast extends MenuAbstract {
 	public static final int ID_MAX_COOK_TIME = 2;
 	public static final int ID_MAX_BURN_TIME = 3;
 
+	private static final int NUM_INGREDIENT_SLOTS = 2;
+	private static final int NUM_FUEL_SLOTS = 1;
+	private static final int NUM_RESULT_SLOTS = 1;
+
+	private static final int INGREDIENT_SLOTS_START = 0;
+	private static final int FUEL_SLOTS_START = INGREDIENT_SLOTS_START + NUM_INGREDIENT_SLOTS;
+	private static final int RESULT_SLOTS_START = FUEL_SLOTS_START + NUM_FUEL_SLOTS;
+	private static final int INVENTORY_SLOTS_START = RESULT_SLOTS_START + NUM_RESULT_SLOTS;
+	private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
+
+
 	public TileEntityFurnaceBlast furnace;
-	private int currentCookTime;
-	private int currentBurnTime;
-	private int itemBurnTime;
-	private int itemCookTime;
+	private int currentCookTime = 0;
+	private int currentBurnTime = 0;
+	private int itemBurnTime = 0;
+	private int itemCookTime = 0;
 
 	public MenuFurnaceBlast(final ContainerInventory inventory, final TileEntityFurnaceBlast tileEntity) {
-        this.currentCookTime = 0;
-        this.currentBurnTime = 0;
-        this.itemCookTime = 0;
-        this.itemBurnTime = 0;
         this.furnace = tileEntity;
 
 		addSlot(new Slot(tileEntity, TileEntityFurnaceBlast.SLOT_LEFT, 46, 17));
@@ -34,14 +41,14 @@ public class MenuFurnaceBlast extends MenuAbstract {
 		addSlot(new Slot(tileEntity, TileEntityFurnaceBlast.SLOT_FUEL, 56, 53));
 		addSlot(new SlotFurnace(inventory.player, tileEntity, TileEntityFurnaceBlast.SLOT_RESULT, 116, 35));
 
-		for (int row = 0; row < 3; row++) {
-			for (int col = 0; col < 9; col++) {
-				addSlot(new Slot(inventory, col + row * 9 + 9, 8 + col * 18, 84 + row * 18));
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(inventory, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 84 + y * 18));
 			}
 
 		}
 
-		for (int i = 0; i < 9; i++) {
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
 			addSlot(new Slot(inventory, i, 8 + i * 18, 142));
 		}
 	}
@@ -104,53 +111,61 @@ public class MenuFurnaceBlast extends MenuAbstract {
 
 	@Override
 	public IntList getMoveSlots(final @NotNull InventoryAction action, final @NotNull Slot slot, final int target, final Player player) {
-		if(slot.index >= 0 && slot.index < 4) return getSlots(slot.index, 1, false);
+		if (slot.index >= INGREDIENT_SLOTS_START && slot.index < FUEL_SLOTS_START) {
+			return getSlots(INGREDIENT_SLOTS_START, NUM_INGREDIENT_SLOTS, false);
+		}
+		if (slot.index >= FUEL_SLOTS_START && slot.index < RESULT_SLOTS_START) {
+			return getSlots(FUEL_SLOTS_START, NUM_FUEL_SLOTS, false);
+		}
+		if (slot.index >= RESULT_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(RESULT_SLOTS_START, NUM_RESULT_SLOTS, false);
+		}
 
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.index >= 4 && slot.index < 31) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(4, 27, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false);
 			}
-			if(slot.index >= 31 && slot.index < 40) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(31, 9, false);
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}
-		if(slot.index >= 4 && slot.index < 40) {
+		if(slot.index >= INVENTORY_SLOTS_START && slot.index < INVENTORY_SLOTS_START + ContainerInventory.MAIN_INVENTORY_SIZE) {
 			// Full ContainerInventory
-			return getSlots(4, 36, false);
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 		}
 		return null;
 	}
 
 	@Override
 	public IntList getTargetSlots(final @NotNull InventoryAction action, final @NotNull Slot slot, final int target, final Player player) {
-		if(slot.index >= 4 && slot.index < 40) {
+		if(slot.index >= INVENTORY_SLOTS_START && slot.index <= INVENTORY_SLOTS_START + ContainerInventory.MAIN_INVENTORY_SIZE) {
 			// Full ContainerInventory
 			if(action != InventoryAction.MOVE_ALL) {
 				if(target == 1) {
-					return getSlots(0, 2, false); // Into Ingredient Slots
+					return getSlots(INGREDIENT_SLOTS_START, NUM_INGREDIENT_SLOTS, false); // Into Ingredient Slot
 				}
 				if(target == 2) {
-					return getSlots(2, 1, false); // Into Fuel Slot
+					return getSlots(FUEL_SLOTS_START, NUM_FUEL_SLOTS, false); // Into Fuel Slot
 				}
 			}
-			if(slot.index >= 4 && slot.index < 31) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(31, 9, false); // Into Hotbar
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false); // Into Hotbar
 			}
-			if(slot.index >= 31 && slot.index < 40) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(3, 27, false); // Into Main ContainerInventory
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false); // Into Main ContainerInventory
 			}
 		}
-		if(slot.index >= 0 && slot.index < 4) {
-			if(slot.index == 3) {
+		if(slot.index >= INGREDIENT_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			if(slot.index == RESULT_SLOTS_START) {
 				// Output
-				return getSlots(3, 36, true);
-			} else {
-				// Inputs and Fuel
-				return getSlots(3, 36, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, true);
+			}else {
+				// Input and Fuel
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 			}
 		}
 
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
index bb72be543..fb649ac49 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.player.inventory.menu;
 
+import com.mojang.nbt.tags.CompoundTag;
 import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.data.registry.Registries;
@@ -16,34 +17,45 @@ import net.minecraft.core.player.inventory.slot.SlotResult;
 import org.jetbrains.annotations.NotNull;
 
 public class MenuInventory extends MenuAbstract {
+	private static final int NUM_CRAFTING_COLUMNS = 2;
+	private static final int NUM_CRAFTING_ROWS = 2;
+	private static final int NUM_RESULT_SLOTS = 1;
+
+	private static final int RESULT_SLOTS_START = 0;
+	private static final int CRAFTING_SLOTS_START = RESULT_SLOTS_START + NUM_RESULT_SLOTS;
+	private static final int ARMOR_SLOTS_START = CRAFTING_SLOTS_START + (NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS);
+	private static final int INVENTORY_SLOTS_START = ARMOR_SLOTS_START + ContainerInventory.ARMOR_INVENTORY_SIZE;
+	private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
 
 	public ContainerCrafting craftSlots;
 	public Container resultSlots;
 	public ContainerInventory inventory;
 
 	public MenuInventory(ContainerInventory inventory) {
-		craftSlots = new ContainerCrafting(this, 2, 2);
-		resultSlots = new ContainerResult();
 		this.inventory = inventory;
+
+		craftSlots = new ContainerCrafting(this, NUM_CRAFTING_COLUMNS, NUM_CRAFTING_ROWS);
+		resultSlots = new ContainerResult();
+
 		addSlot(new SlotResult(inventory.player, craftSlots, resultSlots, 0, 144, 36));
 		
-		for (int i = 0; i < 2; i++) {
-			for (int j = 0; j < 2; j++) {
-				addSlot(new Slot(craftSlots, j + i * 2, 88 + j * 18, 26 + i * 18));
+		for (int y = 0; y < NUM_CRAFTING_ROWS; y++) {
+			for (int x = 0; x < NUM_CRAFTING_COLUMNS; x++) {
+				addSlot(new Slot(craftSlots, x + y * NUM_CRAFTING_COLUMNS, 88 + x * 18, 26 + y * 18));
 			}
 		}
 		
-		for (int i = 0; i < HumanArmorShape.values().length; i++) {
-			addSlot(new SlotArmor(this, inventory, inventory.getContainerSize() - 1 - i, 8, 8 + i * 18, HumanArmorShape.values()[HumanArmorShape.values().length - (i + 1)]));
+		for (int i = 0; i < ContainerInventory.ARMOR_INVENTORY_SIZE; i++) {
+			addSlot(new SlotArmor(this, inventory, ContainerInventory.MAIN_INVENTORY_SIZE + i, 8, 8 + i * 18, HumanArmorShape.values()[ContainerInventory.ARMOR_INVENTORY_SIZE - (i + 1)]));
 		}
 		
-		for (int i = 0; i < 3; i++) {
-			for (int k1 = 0; k1 < 9; k1++) {
-				addSlot(new Slot(inventory, k1 + (i + 1) * 9, 8 + k1 * 18, 84 + i * 18));
+		for (int y = 0; y < (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE) / NUM_COLUMNS; y++) {
+			for (int x = 0; x < NUM_COLUMNS; x++) {
+				addSlot(new Slot(inventory, x + y * NUM_COLUMNS + ContainerInventory.HOTBAR_SIZE, 8 + x * 18, 84 + y * 18));
 			}
 		}
 		
-		for (int i = 0; i < 9; i++) {
+		for (int i = 0; i < ContainerInventory.HOTBAR_SIZE; i++) {
 			addSlot(new Slot(inventory, i, 8 + i * 18, 142));
 		}
 
@@ -59,7 +71,7 @@ public class MenuInventory extends MenuAbstract {
 	public void onCraftGuiClosed(@NotNull Player player) {
 		super.onCraftGuiClosed(player);
 		boolean insert = false;
-		for (int i = 0; i < 4; i++) {
+		for (int i = 0; i < NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS; i++) {
 			ItemStack itemstack = craftSlots.getItem(i);
 			if(itemstack != null) {
 				craftSlots.setItem(i, null);
@@ -87,31 +99,31 @@ public class MenuInventory extends MenuAbstract {
 
 	@Override
 	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index == 0) {
+		if(slot.index >= RESULT_SLOTS_START && slot.index < CRAFTING_SLOTS_START) {
 			// Craft Result
-			return getSlots(0, 1, false);
+			return getSlots(RESULT_SLOTS_START, NUM_RESULT_SLOTS, false);
 		}
-		if(slot.index >= 1 && slot.index <= 4) {
+		if(slot.index >= CRAFTING_SLOTS_START && slot.index < ARMOR_SLOTS_START) {
     		// Crafting Grid
-			return getSlots(1, 4, false);
+			return getSlots(CRAFTING_SLOTS_START, NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS, false);
 		}
-		if(slot.index >= 5 && slot.index <= 8) {
+		if(slot.index >= ARMOR_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
 			// Armor
-			return getSlots(5, 4, false);
+			return getSlots(ARMOR_SLOTS_START, ContainerInventory.ARMOR_INVENTORY_SIZE, false);
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			if(slot.index >= 9 && slot.index <= 44) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Full ContainerInventory
-				return getSlots(9, 36, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 			}	
 		}else {
-			if(slot.index >= 9 && slot.index <= 35) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(9, 27, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false);
 			}
-			if(slot.index >= 36 && slot.index <= 44) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(36, 9, false);
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}
 		return null;
@@ -119,29 +131,29 @@ public class MenuInventory extends MenuAbstract {
 	
 	@Override
 	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 9 && slot.index <= 44) {
+		if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 			// Full ContainerInventory
 			if(target == 1) {
-				return getSlots(1, 4, false); // Crafting
+				return getSlots(CRAFTING_SLOTS_START, NUM_CRAFTING_COLUMNS * NUM_CRAFTING_ROWS, false); // Crafting
 			}
 			if(target == 2) {
-				return getSlots(5, 4, false); // Armor
+				return getSlots(ARMOR_SLOTS_START, ContainerInventory.ARMOR_INVENTORY_SIZE, false); // Armor
 			}
 			
-			if(slot.index < 36) {
+			if(slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(36, 9, false); // Hotbar
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false); // Hotbar
 			}else {
 				// Hotbar
-				return getSlots(9, 27, false); // Main ContainerInventory
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false); // Main ContainerInventory
 			}
 		}else {
-			if(slot.index == 0) {
+			if(slot.index == RESULT_SLOTS_START) {
 				// Crafting Result
-				return getSlots(9, 36, true); // Full ContainerInventory, Last First
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, true); // Full ContainerInventory, Last First
 			}else {
 				// Crafting Grid and Armor
-				return getSlots(9, 36, false); // Full ContainerInventory
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false); // Full ContainerInventory
 			}
 			
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
index c46bf0af7..e75bfa955 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventoryCreative.java
@@ -22,7 +22,7 @@ public class MenuInventoryCreative extends MenuInventory
 	public int page = 0;
 	public int maxPage;
 	protected int creativeSlotsStart;
-	protected List<ItemStack> searchedItems = new ArrayList<ItemStack>();
+	protected List<ItemStack> searchedItems = new ArrayList<>();
 	public String searchText = "";
 
 	public MenuInventoryCreative(ContainerInventory inventoryplayer)
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
index bb4777307..05a3ef5ea 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
@@ -11,6 +11,13 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import org.jetbrains.annotations.NotNull;
 
 public class MenuTrommel extends MenuAbstract {
+	private static final int NUM_INGREDIENT_SLOTS = 4;
+	private static final int NUM_FUEL_SLOTS = 1;
+
+	private static final int INGREDIENT_SLOTS_START = 0;
+	private static final int FUEL_SLOTS_START = INGREDIENT_SLOTS_START + NUM_INGREDIENT_SLOTS;
+	private static final int INVENTORY_SLOTS_START = FUEL_SLOTS_START + NUM_FUEL_SLOTS;
+	private static final int HOTBAR_SLOTS_START = INVENTORY_SLOTS_START + (ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE);
 
 	private TileEntityTrommel trommel;
 	private int cookTime = 0;
@@ -87,26 +94,26 @@ public class MenuTrommel extends MenuAbstract {
 
 	@Override
 	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 0 && slot.index <= 3) {
-			return getSlots(0, 4, false);
+		if(slot.index >= INGREDIENT_SLOTS_START && slot.index < FUEL_SLOTS_START) {
+			return getSlots(INGREDIENT_SLOTS_START, NUM_INGREDIENT_SLOTS, false);
 		}
-		if(slot.index == 4) {
-			return getSlots(4, 1, false);
+		if(slot.index >= FUEL_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
+			return getSlots(FUEL_SLOTS_START, NUM_FUEL_SLOTS, false);
 		}
 		if(action == InventoryAction.MOVE_ALL) {
-			if(slot.index >= 5 && slot.index <= 31) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(5, 27, false);
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false);
 			}
-			if(slot.index >= 32 && slot.index <= 40) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(32, 9, false);
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false);
 			}
 		}
 		if(action == InventoryAction.MOVE_SIMILAR) {
-			if(slot.index >= 5 && slot.index <= 40) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Full ContainerInventory
-				return getSlots(5, 36, false);
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false);
 			}
 		}
 		return null;
@@ -114,25 +121,25 @@ public class MenuTrommel extends MenuAbstract {
 
 	@Override
 	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
-		if(slot.index >= 0 && slot.index <= 4) {
+		if(slot.index >= INGREDIENT_SLOTS_START && slot.index < INVENTORY_SLOTS_START) {
 			// Item and Fuel Slots
-			return getSlots(5, 36, false); // Into ContainerInventory
+			return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE, false); // Into ContainerInventory
 		}
-		if(slot.index >= 5 && slot.index <= 40) {
+		if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 			if(target == 1) {
-				return getSlots(0, 4, false); // Into Item Slots
+				return getSlots(INGREDIENT_SLOTS_START, NUM_INGREDIENT_SLOTS, false); // Into Item Slots
 			}
 			if(target == 2) {
-				return getSlots(4, 1, false); // Into Fuel Slot
+				return getSlots(FUEL_SLOTS_START, NUM_FUEL_SLOTS, false); // Into Fuel Slot
 			}
 			
-			if(slot.index >= 5 && slot.index <= 31) {
+			if(slot.index >= INVENTORY_SLOTS_START && slot.index < HOTBAR_SLOTS_START) {
 				// Main ContainerInventory
-				return getSlots(32, 9, false); // Into hotbar
+				return getSlots(HOTBAR_SLOTS_START, ContainerInventory.HOTBAR_SIZE, false); // Into hotbar
 			}
-			if(slot.index >= 32 && slot.index <= 40) {
+			if(slot.index >= HOTBAR_SLOTS_START && slot.index < HOTBAR_SLOTS_START + ContainerInventory.HOTBAR_SIZE) {
 				// Hotbar
-				return getSlots(5, 27, false); // Into ContainerInventory
+				return getSlots(INVENTORY_SLOTS_START, ContainerInventory.MAIN_INVENTORY_SIZE - ContainerInventory.HOTBAR_SIZE, false); // Into ContainerInventory
 			}
 		}
 		return null;
diff --git a/game/core/src/main/java/net/minecraft/core/world/Dimension.java b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
index 7df0f373a..3ec417331 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Dimension.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Dimension.java
@@ -13,20 +13,16 @@ import net.minecraft.core.world.type.WorldTypes;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Collections;
-import java.util.HashMap;
-import java.util.Map;
-
 public class Dimension
 {
 	public int id;
 	public final String languageKey;
 	public final Dimension homeDim;
-	public final WorldType defaultWorldType;
+	public final @NotNull WorldType defaultWorldType;
 	public final float worldScale;
 	public final @Nullable Block<? extends BlockLogicPortal> portalBlock;
 	
-	public Dimension(String languageKey, Dimension homeDim, float worldScale, @Nullable Block<? extends BlockLogicPortal> portalBlock, WorldType defaultWorldType)
+	public Dimension(String languageKey, Dimension homeDim, float worldScale, @Nullable Block<? extends BlockLogicPortal> portalBlock, @NotNull WorldType defaultWorldType)
 	{
 		this.languageKey = languageKey;
 		this.homeDim = homeDim;
@@ -39,9 +35,9 @@ public class Dimension
 	{
 		if (world.dimension == this)
 		{
-			return world.dimensionData;
+			return world.getDimensionData();
 		}
-		DimensionData dimensionData = world.saveHandler.getDimensionData(this.id);
+		DimensionData dimensionData = world.getLevelStorage().getDimensionData(this.id);
 		if (dimensionData == null) dimensionData = new DimensionData(this.defaultWorldType);
 		
 		return dimensionData;
